Package org.eclipse.rdf4j.common.concurrent.locks

## Class LockingIteration<E,​X extends Exception>

- java.lang.Object
- - org.eclipse.rdf4j.common.iteration.AbstractCloseableIteration<E,​X>
  - - org.eclipse.rdf4j.common.iteration.IterationWrapper<E,​X>
    - - org.eclipse.rdf4j.common.concurrent.locks.LockingIteration<E,​X>

- All Implemented Interfaces:
    `AutoCloseable`, `CloseableIteration<E,​X>`, `Iteration<E,​X>`

      public class LockingIteration<E,​X extends Exception>
      extends IterationWrapper<E,​X>

  An Iteration that holds on to a lock until the Iteration is closed. Upon closing, the underlying Iteration is closed before the lock is released. This iterator closes itself as soon as all elements have been read.

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.rdf4j.common.iteration.IterationWrapper

      `wrappedIter`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `LockingIteration​(Lock lock, Iteration<? extends E,​X> iter)` | Creates a new LockingIteration.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static <T,​R extends Exception> CloseableIteration<T,​R>` | `getInstance​(Lock lock, CloseableIteration<T,​R> iter)` |
    `protected void` | `handleClose()` | Closes this Iteration and also closes the wrapped Iteration if it is a `CloseableIteration`.

    - ### Methods inherited from class org.eclipse.rdf4j.common.iteration.IterationWrapper

      `hasNext, next, remove`

    - ### Methods inherited from class org.eclipse.rdf4j.common.iteration.AbstractCloseableIteration

      `close, isClosed`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.rdf4j.common.iteration.Iteration

      `stream`

- - ### Constructor Detail

    - #### LockingIteration

          public LockingIteration​(Lock lock,
                                  Iteration<? extends E,​X> iter)

      Creates a new LockingIteration.
      Parameters:
        `lock` - The lock to release when the itererator is closed, must not be null.
        `iter` - The underlying Iteration, must not be null.

  - ### Method Detail

    - #### getInstance

          public static <T,​R extends Exception> CloseableIteration<T,​R> getInstance​(Lock lock,
                                                                                                CloseableIteration<T,​R> iter)

    - #### handleClose

          protected void handleClose()
                              throws X extends Exception

      Description copied from class: `IterationWrapper`
      Closes this Iteration and also closes the wrapped Iteration if it is a `CloseableIteration`.
      Overrides:
        `handleClose` in class `IterationWrapper<E,​X extends Exception>`
      Throws:
        `X`
        `X extends Exception`